=== doc/CMakeLists.txt ===
if (NOT WIN32)
    add_subdirectory(man)
endif()

if(TSD_HTML_DOCUMENTATION)
    add_subdirectory(html)
endif()
