=== debian/changelog ===
tango (9.5.0+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Santiago Ruano Rincón <santiago@freexian.com>  Tue, 09 Jan 2024 07:20:11 -0500

tango (9.5.0+dfsg1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 9.5.0+dfsg1 (Closes: #1057877)
    * Import CMakeLists patches that fix finding the IDL path
    * Add d/patches/0001-tango_admin.cpp-Fix-ping-device-timeout-parsing.patch
      to fix regression in tango_admin --ping-device
      See: https://gitlab.com/tango-controls/tango_admin/-/issues/15
      Thanks to Thomas Braun
    * Update patches
  * Add Build-Depends on python3-sphinx-copybutton
  * d/rules: install migrate_db_tables_innodb.sql in tango-db
  * Bump SONAME to libtango95
  * Update d/copyright. Remove superfluous file patterns

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 15 Dec 2023 14:47:30 -0300
